package;

import flash.geom.*;
import flash.events.*;
import flash.display.*;
import openfl.Assets;
import openfl.Lib;
import openfl.display.FPS;
import org.si.cml.*;
import org.si.cml.core.CMLSinTable;
import org.si.cml.core.CMLState;


import flash.geom.Rectangle;
import flash.display.BitmapData;
import org.si.cml.CMLObject;

// cannonML particle test
class Main extends Sprite {
	
	// cannonML script
	/*
	 * bs0,	// barrage 0 => infinitely
	4,		// increment angle 
	,		// increment speed
	10		// Wait
	bm		// Fire -> Barrage
		5,		// # bullets
		360		// angle range (deg)
		f		// Fire -> standard
		10		// Speed
		{		// Simulatenous
			i30v
			w90
			br5,	// barrage random, 5 shots
				360,	// angle range
				2,		// speed range
				2		// time interval
				f4		// First -> standard
				{
					i30v~ko	// velocity vx/vy -> v0 in 30, wait 30, destroy
				}
			w10ay0.05
		}
	*/
	//private var script:String = "bs,4,, 10bm1, 360f10{i30v0w90br5, 360, 2, 2f4{i30v~ko}w10ko}";
	//private var script:String = "bs,4,, 10bm5, 360f10{i30v0w90br5, 360, 2, 5 f4{i30v~ko}w10ay0.05}";
	/*private var script:String = "{ [f3w30] }
								v1, 1 w60 [v - 2, 0 w60 v2, 0 w60]";*/
	//private var script:String = "[f3w30]5";
	/*private var script:String = "ha60 f3 w60
								ht0f3 w60
								hs10 [f3w5]4";*/
	/*private var script:String = "i0   p 90,120v0,-3
								i180 p - 90, 120v0, -3";  // End   at (-90,120) with velocity of (0,-3)";*/
	//private var script:String = "i120 p-60,120v5,0 ~ p60,80v0,-2 ~ p0,0";
	/*private var script:String = "a0,-0.05 w60
								v0,0 ht0 ad0.1";*/
								
	private var script:Array<String> = ["i30 csa3  ~"  // [0] Change the speed to 3 in 60 frames
										+ "i30 csr-2 ~"  // Change the speed to 1(=3-2) in 30 frames
										+ "i999css-0.1"  // Change the speed with the accelaration of -0.1",
		,"csa2"	// [1]
			+ "i60 ha-180 cd ~" // Change the direction to upper in 60 frames
			+ "i60 hs5    cd ~" // Change the direction in 5 degree for each frames
			+ "i1  ht0  [cd3w1]" // Change the direction to the player with a maximum rotation of 2 degree."
		,"gp1,5"	// [2]
			+ "p-90,120 w150"
			+ "p 90,120 w150"
			+ "p  0,  0 w150"
			+ "gp0,0"
		,"bm7,120 f3"	// [3]
		,"bm7,0,3 f3"	// [4]
		,"bm7,0,0,10 f3"	// [5]
		,"bm20,360 f3"	// [6]
		,"ha0 bm7,20,2,5 f3"	// [7]
		,"ha0 bs7,3,0.5,10 f3"	// [8]
		,"ha0 bs0,5,0,5 f3"	// [9]
		,"br20,60,2,5 f3"	// [10]
		,"ha0"	// [11]
			+ "bm5,0,2 f3 w90"
			+ "bm3,30 f3 w90"
			+ "bm5,0,2 bm3,30 f3"
		,"ha0"	// [12]
			+ "bm5,20,1 f3 w90 "
			+ "bm12,360 f3 w90 "
			+ "bm5, 20, 1 bm12, 360 f3"
		,"ha0"	// [13]
			+ "br20,360,0,2 f4 w90 "
			+ "bm5,0,2 f4 w90 "
			+ "br20,360,0,2 bm5,0,2 f4"
		,"[q-20,0 f3 q20,0 f3 w30]"	// [14]
		,"bv0.5f3[w10f]4 w90"	// [15]
			+ "bs5,0,0.5,10f3"
		,"ha-20bv0.5f3hs10[w10f]4 w90"	// [16]
			+ "habm5,40,0.5,10f4"
		,"{ho0 [f3w10]} i120ha180r0,0 w180" // 	// [17]Rotation starts from speed 0 and ends with speed 0.
			+ "i120ha0  r2,0 w180" // Rotation deccelate.
			+ "i0  ha90 r"         // Change objects angle."
		,"f0{p-90,60 [ht0  bs5,0,0,12f3 w120]}"	// [18]
			+ "f0{p 90,60 [htx0 bs5,0,0,12f3 w120]}"
		,"q45,30 nc{ho[w10f2]}"	// [19]
			+ "i60[p-45,30~ho180r~p45,30~ho180r~p~]"
		,"bm8,360fc3{i30v[w60f4]}"	// [20]
			+ "{i120[ho360r0,0~]}i60[p-45,30~~p45,30~~p~]"
		,"@{[f3w30]} v1,1 w60 [v-2,0 w60 v2,0 w60]"	// [21]
		,"q-80,80 n{ @1{[f4w30]} w200 @1{[bm2,60f2w70]} }"	// [22]  // left enemy overwrites the sequence.
			+ "q 80,80 n{ @ {[f4w30]} w200 @ {[bm2,60f2w70]} }"  // right enemy doesnt overwrite the sequence."
		,"& {[f3w30]} v1,1 w60 [v-2,0 w60 v2,0 w60]"	// [23]	// KO & sans variable
		,"n{v0,5i30v3,0~v0,-3} w60 n{.}"	// [24]
		,"n{v0,5i30v3,0~v0,-3} & {w30} f0{ad0.1} w30"	// [25]		// KO & sans variable
			+ "n{.} &{.} f0{.}"
		,"{q-30 bm5,-40,2 ha40f4} w60 m{.} w m1{.} w m2{.} w"	// [26]
			+ "n{v0,5i30v3,0~v0,-3} w mn{.} w m1n{.} w m2n{.}"
		,"q-45,80 n1{}" 	// [27]  // Left   enemy has id=1.
			+ "q  0,80 n2{}"   // Center enemy has id=2.
			+ "q 45,80 n1{}"   // Right  enemy has id=1.
			+ "q0,0 [w60 @o1{f3} w60 @o2{f3w5f3}]"
		,"@ko1{f3} w120 ko1"	// [28]
		,"#ROTFIRE{i120ho360rbm4,360ho[24f3w5]}"	// [29]	// KO....
			+ "i120p-90,-80~ & ROTFIRE i120p90,-80~ & ROTFIRE"
			+ "i120p-90,-80~ ROTFIRE i120p90,-80~ ROTFIRE"
		,"{[w?($x<170)*($x>-170) vx-$vx w2]}"	// [30]	// KO
			+ "{[w?($y<170)*($y>-170) vy-$vy w2]}"
			+ "v-5,3"
		,"[[ha$l1*10-90rqx$l*10-50f3]10w30]18"	// [31]
		,"py-90 br1,60 ha0 [f3{ay0.1w?($t.y>$y)v-$sx*2,0}w20]"	// [32]	// Target reference
		,"q-120,-90n{[w?$p.x>0f5w10]}"	// [33]	// Parent reference
			+ "q120,-90n{[w?$p.x<0f5w10]}"
			+ "i60gp0.5,2 [p80,20~p-40,-20~p40,-20~p-80,20~]"
		,"[6 n1{&life5 ha$??*90+180vd5 i30v~ht[w120f2]}w10]"	// [34]	// Refer children count
			+ "{i60[p-60,0~p60,0~]} [w?$o1>5 n1{.} w30]"
		,"#B{bm$1, 360bm$2, 15, 5, 1}i20py - 120~ha$? * 360[s?$r & B 12, 12:40 &B 12, 14:70 & B 14,14:110 & B 16, 14:140& B 18, 14:190 & B 20, 14]f7{1}w60ay0.1" // [35]
		,"[f2{ bm8,360fc3,1{i30v} @ko{@o1{ko2}} [i1 ho20 rc5w1]50 kf} w140]" // [36]
		,""
		,""];
	//private var script:String = "@{[bm7,120 f3 w1200]} v1,1 w60 [v-2,0 w60 v2,0 w60]"; // barrage
	//private var script:Xml = Xml.parse(Assets.getText("bulletml/[Progear]_round_1_boss_grow_bullets.xml"));
	
	private var _player:Particle;
	
	// For managing time between two frames
	private var _lastFrame:Int = 0;
	private var _elapsedTime:Float = 0;
	
	function new() {
		super();
		
		var sin = new CMLSinTable();
		
		CMLObject.initialize(true);
		// Dummy command, crash if there's no UserCommand...
		CMLSequence.registerUserCommand("lol", lol);
		
		_player = new Particle();    // Player class is your extention of CMLObject.
		_player.setAsDefaultTarget();            // Default target is the object to fire at.
		_player.color = 0x9966cc;
		_player.x = 40;
		_player.y = 200;
		
		var seed:Particle = new Particle();
		seed.create(0, 0);
		
		// TESTING HERE, see "script" var for the corresponding index ===================
		seed.execute(new CMLSequence(script[36]));
		addChild(new Bitmap(Particle.field));
		
		addChild(new FPS(10, 10, 0xffffff));
		
		addEventListener(Event.ENTER_FRAME, enterFrame);
	}
	
	function enterFrame(e:Event) : Void
	{
		_elapsedTime = (Lib.getTimer() - _lastFrame);
		_lastFrame = Lib.getTimer();
		
		Particle.field.colorTransform(Particle.field.rect, colt);
		CMLObject.frameUpdate(CMLState.timeRatio);
		
		_player.x = mouseX - 231;
		_player.y = mouseY - 231;
	}
	
	private var colt:ColorTransform = new ColorTransform(.875,.875,.875);
	private var hue:Int = 0;
	
    private function lol(fbr:CMLFiber, args:Array<Dynamic>):Void {
    }
	
}

class Particle extends CMLObject
{
    public var color:Int;
    static public var field:BitmapData = new BitmapData(465, 465, false, 0);
    static private var _freeList:Array<Particle> = [];
    static private var _rect:Rectangle = new Rectangle(0,0,3,3);
    static private function _new() : Particle
	{
		var p:Particle = _freeList.pop();
		if (p == null)
			p = new Particle();
		
		return p; 
	}
    
    public function new()
	{
		color = 0x00ff00;
		super();
	}
	
    override public function onNewObject(args:Array<Dynamic>) : CMLObject
	{
		return _new();
	}
    override public function onFireObject(args:Array<Dynamic>) : CMLObject
	{
		return _new();
	}
	
    override public function onDestroy() : Void 
	{
		_freeList.push(this);
	}
	
    override public function onUpdate() : Void
	{
        _rect.x = x+231;
        _rect.y = y+231;
        field.fillRect(_rect, color);
        if (this.x<-235 || this.x>235|| this.y<-235 || this.y>235) this.destroy(0);
    }
}


/*
package {
    import flash.geom.*;
    import flash.events.*;
    import flash.display.*;
    import org.si.cml.*;
    import frocessing.color.FColor;

    // cannonML particle test
    public class FirstSample extends Sprite {
        
        // cannonML script
        private var script:String = "bs,4,,10bm5,360f10{i30vw90br5,360,2,2f4{i30v~ko}w10ay0.05}";
        
        function FirstSample() {
            CMLObject.initialize(true);
            var seed:Particle = new Particle();
            seed.create(0, 0);
            seed.execute(new CMLSequence(script));
            addChild(new Bitmap(Particle.field));
            addEventListener(Event.ENTER_FRAME, function(e:Event) : void {
                Particle.field.colorTransform(Particle.field.rect, colt);
                Particle.color = FColor.HSVtoValue(hue++, .75, 1, 1);
                CMLObject.update();
            });
        }
        
        private var colt:ColorTransform = new ColorTransform(.875,.875,.875);
        private var hue:Number = 0;
    }
}


import flash.geom.Rectangle;
import flash.display.BitmapData;
import org.si.cml.CMLObject;

class Particle extends CMLObject {
    static public var color:uint;
    static public var field:BitmapData = new BitmapData(465, 465, false, 0);
    static private var _freeList:Array = [];
    static private var _rect:Rectangle = new Rectangle(0,0,3,3);
    static private function _new() : Particle { return _freeList.pop() || new Particle(); }
    
    function Particle() {}
    override public function onNewObject(args:Array) : CMLObject { return _new(); }
    override public function onFireObject(args:Array) : CMLObject { return _new(); }
    override public function onDestroy() : void { _freeList.push(this); }
    override public function onUpdate() : void {
        _rect.x = x+231;
        _rect.y = y+231;
        field.fillRect(_rect, color);
        if (this.x<-235 || this.x>235|| this.y<-235 || this.y>235) this.destroy(0);
    }
}

*/